\ Search order

.( Loading Search order words...)

7 value #threads

: #wordlist ( n -- wid )
    dup ,  ['] (voc-search) ,  voc-link link,
    here dup>r over cells allot
    swap cells erase r> ;
: wordlist     #threads #wordlist ;

: #vocabulary ( n -- )
    create #wordlist drop
    does> body> vcfa>voc context ! ;
: vocabulary   #threads #vocabulary ;

: definitions
    context @ current ! ;

: vocs
    voc-link
    begin @ ?dup
    while dup vlink>voc voc>vcfa .name
    repeat cr ;

1 #vocabulary root

' root vcfa>voc dup current ! context cell+ !
' root cell+ @ ' forth cell+ !

: only
    context #vocs cells erase
    root context dup @ swap cell+ ! ;

: also
    context dup cell+ #vocs 1- cells move ;

: previous
    context dup cell+ swap #vocs 1- cells move ;

: order
    ." CONTEXT: "
    context
    begin lcount ?dup
    while voc>vcfa .name
    repeat drop cr
    ." CURRENT: " current @ voc>vcfa .name cr ;

: forth forth ;

: set-current
    current ! ;
: get-current
    current @ ;
: get-order
    0 context #vocs 1- cells+
    begin dup @ ?dup
      if -rot 1 under+ then
      cell- dup context <
    until
    drop ;
: set-order
    context #vocs cells erase
    0 ?do context i cells+ ! loop ;

only forth also definitions

.( OK) cr